#ifndef PB_BG_H
#define PB_BG_H
#include "kernel.h"
#include "types.h"

namespace poobear
{
   class Background : public Module
   {
      public:
         Background(u16*, u16*, u16);
         ~Background();

         void insert();
         void clean();
         void step(){ scroll(&scrollVelocity);}

         int getTile(const Vector2D* const);
         void scroll(const Vector2D* const);
         void setWrapAround(bool);

      private:
         Vector2D scrollVelocity;
   };


   class BackgroundManager
   {
      public:
         static BackgroundManager* getInstance();

         void addBackground(Background*);
         void removeBackground(Background*);

      private:
         BackgroundManager();

         static BackgroundManager* theInstance;

   };
};

#endif

