#ifndef PB_SPRITE_H
#define PB_SPRITE_H
#include "kernel.h"

namespace poobear
{
	class Sprite : public Module
	{
		public:
			Sprite(unsigned char* pixels,
					short vx = 0, 
					short vy = 0,
				  	short width = 1, 
					short height = 1, 
					int priority = 100);

			virtual void insert();
			virtual void clean();
			virtual void step() { move(); }

			void move();
			void stop();
			void moveTo(short x, short y);
		//	virtual void setVisible(bool);

			short getX() const { return x; }
			short getY() const { return y; }
			short getWidth() const { return width; }
			short getHeight() const { return height; }
			unsigned char* getPixels() const { return data; }
			OAMEntry* getOAM() const { return oam; }

			short vx, vy;

		protected:
			OAMEntry* oam;
			short width, height, x, y;
			unsigned char* data;
	};

	class SpriteManager
	{
		public:
			static SpriteManager& getInstance(bool useLowerVideoMem = false);

			OAMEntry* addSprite(Sprite*);
			void removeSprite(Sprite*);

		private:
			SpriteManager(bool);

			short vmemUsed, oamemUsed;
			static SpriteManager* theInstance;
	};
};
#endif

